import pandas as pd


class DataUtil:
    def __init__(self, file_path: str, sheet_name: str = ''):
        ext = file_path.rsplit('.', 1)[1]
        if ext == 'csv':
            encoding_list = ['utf-8', 'EUC-KR', 'CP949', 'iso-8859-1']
            i = 0
            while True:
                try:
                    # low_memory is set due to DtypeWarning
                    self.df = pd.read_csv(file_path, encoding=encoding_list[i], low_memory=False)
                    break
                except UnicodeDecodeError:
                    i += 1
                    continue

        elif ext == 'xls' or ext == 'xlsx':
            self.df = pd.read_excel(
                file_path, sheet_name=sheet_name
            )

    def get_data_frame(self):
        return self.df

    def get_sheet_list(self) -> list:
        return list(self.df.keys())
